/* 
 * itschere20001023: merely a small test program
 */

#include <math.h>
#include <rccl.h>

static int fxn (int arg, MANIP *mnp)
{
  TRSF *t = allocTrans ();   /* this should fail */
}


static void test1 (MANIP *mnp)
{
  TRSF *t;
  POS *p;

  t = allocTransTrans (mnp->t6);

  printTrsf ("%m\n", t);

#if 0
  runMonitorFxn (mnp, fxn, 0);
#endif

  setAccelScale (mnp, 0.5);

  while (42)
    {
      t->p.z -= 25.0;

      p = makePosition (NULL, T6, EQ, t, NULL);
      move (mnp, p);
      waitForCompleted (mnp);
      freePosition (p);

      t->p.z += 25.0;

      p = makePosition (NULL, T6, EQ, t, NULL);
      move (mnp, p);
      waitForCompleted (mnp);
      freePosition (p);

      // break;
    }

  freeTrans (t);
}


static void test2 (MANIP *mnp)
{
	setSpeed (mnp, 1.7);
  setAccelScale (mnp, 0.2);

	/* */

#if 0

	JNTS j1 = {{-0.0 * M_PI / 180.0,
							0,
							0,
							+170.0 * M_PI / 180.0,
							0,
							0}};

	JNTS j2 = {{+0.0 * M_PI / 180.0,
							0,
							0,
							-170.0 * M_PI / 180.0,
							0,
							0}};

	while (42)
		{
			movej (mnp, &j1);
			waitForCompleted (mnp);
			movej (mnp, &j2);
			waitForCompleted (mnp);
		}

#endif
	
	JNTS jZero = {{0,
		       -15.0 * M_PI / 180.0,
		       50.0 * M_PI / 180.0,
		       0,
		       -35.0 * M_PI / 180.0,
		       0}};
	
	movej (mnp, &jZero);
	waitForCompleted (mnp);
	
	/* */
	
	TRSF *t = allocTransTrans (mnp->t6o);

  TRSF *t1 = allocTransXyz (-50, -50, -100);
  TRSF *t2 = allocTransXyz ( 50, -50, -100);
  TRSF *t3 = allocTransXyz ( 50,  50, -100);
  TRSF *t4 = allocTransXyz (-50,  50, -100);

	POS *p1 = makePosition (NULL, T6, EQ, t, t1, NULL);
	POS *p2 = makePosition (NULL, T6, EQ, t, t2, NULL);
	POS *p3 = makePosition (NULL, T6, EQ, t, t3, NULL);
	POS *p4 = makePosition (NULL, T6, EQ, t, t4, NULL);

	setMod (mnp, 'j');

	move (mnp, p1);
	waitForCompleted (mnp);

	setMod (mnp, 'c');

	/* */

	setSpeed (mnp, 0.50);
	setAccelScale (mnp, 0.25);

	while (42)
		{
			move (mnp, p1);
			waitForCompleted (mnp);

			move (mnp, p2);
			waitForCompleted (mnp);

			move (mnp, p3);
			waitForCompleted (mnp);

			move (mnp, p4);
			waitForCompleted (mnp);
		}
}


int main (int argc, char **argv)
{
  MANIP *mnp;

  argc--;
  argv++;

  if ((argc < 1) || (argc > 2))
    {
      fprintf (stderr, "usage: movec [-sim] <robot>\n");
      return -1;
    }

  if (!strcasecmp (*argv, "-sim"))
    {
      rcclSetOptions (RCCL_SIMULATE);
      argv++;
      argc--;
    }

  if (!(mnp = rcclCreate (*argv)))
    {
      printErrors ();
      return -1;
    }

  if (!mnp->jls)
    {
      fprintf (stderr, "error: robot is virtual\n");
      return -1;
    }

	rcclSetModes (mnp, T6O_EVAL);

  rcclStart ();

	//test1 (mnp);
	test2 (mnp);

  rcclRelease (~0);

  rcclDelete (mnp);

  return -1;
}
