#include <rccl.h>

int main()
{
	TRSF_PTR p, t, t1, t2;                                  /*#1*/
	POS_PTR pos, pos1, pos2;                                /*#2*/
	MANIP *mnp;                                             /*#3*/
	JNTS rcclpark;                                          /*#4*/
	char *robotName; 
	
	static float accelValues[] = { F_DEFAULT, 4000.0, 20.0 };
	static char *accelDesc[] = { "default", "high", "low" };
	static float velValues[] = { F_DEFAULT, 400.0, 40.0 };
	static char *velDesc[] = { "default", "fast", "slow" };/*#5*/

	rcclSetOptions (RCCL_ERROR_EXIT);                       /*4*/
	rcclSetOptions (RCCL_SIMULATE);
	robotName = "left";                        /*#7*/
	if (!getRobotPosition (rcclpark.v, "rcclpark", robotName))
	{
		printf ("position 'rcclpark' not defined for robot\n");
		return (-1);
	}
	                                                        /*#8*/
	/* rechtshändig x = rechts, y = unten, z = vorne (in mm) */
	/*t = allocTransXyz(10.0, 20.0, -10.0);*/
	t = allocTransXyz(-300.0, 300.0, -400.0);
	/*t1 = allocTransXyz(-10.0, 0.0, 250.0);
	t2 = allocTransXyz(-10.0, 10.0, 250.0);
	/*t = allocTransXyz (10.0, 20.0, -10.0);*/
	p = allocTransRot(0, 1, 0, xunit, 0.0);
	pos = makePosition("pos", T6, t, EQ, p, NULL);          /*#9*/

	mnp = rcclCreate (robotName);                           /*#10*/
	rcclStart();

	movej (mnp, &rcclpark);                                 /*#11*/
	stop(mnp, 1000.0);
	waitForCompleted (mnp);
	
	readTrans(mnp->t6, p);
/*	pos = makePosition("pos", T6, EQ, p, t, NULL);          /*#9*/
/*	pos1 = makePosition("pos1", T6, EQ, p, t1, NULL);       /*#9*/
/*	pos2 = makePosition("pos2", T6, EQ, p, t2, NULL);       /*#9*/

	setMod(mnp, 'c');                                       /*#12*/
	move(mnp, pos);                                         /*#13*/
	stop(mnp, 1000.0);
	waitForCompleted (mnp);                                 /*11*/

#if 0
	move(mnp, pos1);
	stop(mnp, 10000.0);
	waitForCompleted (mnp);                                 /*11*/
	move(mnp, pos2);
	stop(mnp, 10000.0);
	waitForCompleted (mnp);                                 /*11*/
#endif

	movej (mnp, &rcclpark);                                 /*#14*/
	stop (mnp, 1000.0);

	waitForCompleted (mnp);                                 /*#15*/
	rcclRelease (YES);                                      /*#16*/

	return 0;
}
