#ifdef CONFIGFILE
#include CONFIGFILE
#endif
#include <rccl.h>
#include "manex.560.h"

#ifdef Vxw_TARGET
#define main track_560_
#endif

main()
{
	TRSF_PTR p, track;
	POS_PTR p1;
	MANIP *mnp;
	TRACK_CTRL_BLK *tcb;

	extern trackFxn();

	rcclSetOptions(RCCL_ERROR_EXIT);

	tcb = ALLOC_MEM(NULL, TRACK_CTRL_BLK, UNDEF);	/*1 */

	p = allocTransRot(NULL, UNDEF, P_X, P_Y, P_Z, xunit, 180.0);
	track = allocTrans(NULL, UNDEF);

	p1 = makePosition(NULL, T6, EQ, p, track, TL, T6);

	mnp = rcclCreate(getDefaultRobot(), 0);
	rcclStart();

	tcb->compute = YES;
	tcb->gain = 1.0;
	tcb->vlimit = 200.0;
	tcb->mnpAddr = (void *)mnp;

	transEval(track, trackFxn, (int)tcb);	/*2 */
	rcclBlock();
	rcclBlock();

	move(mnp, p1);		/*3 */
	stop(mnp, F_UNDEF);

	while (1) {		/*4 */
		printf("%7.4f %7.4f\n", tcb->xval, tcb->yval);
		delay(500.0);
	}
}
